import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.ByteArrayOutputStream;
import java.io.BufferedInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import com.adobe.dp.office.conv.*;
import com.adobe.dp.office.metafile.*;

public class MF2IMG
{

    public static void main(String[] args)
    {
        try
        {
            String userDir=System.getProperty("user.dir");
            File f =  new File(userDir+"//"+args[0]);

            String outPNGFile=userDir+"/"+args[0]+".png";

            MF2IMG mf2img = new MF2IMG();

            if(f.getAbsolutePath().endsWith(".emf"))
            {
                mf2img.doConvertEMF2IMG(f.getAbsolutePath(),outPNGFile);
            }
            else
            {
                mf2img.doConvertWMF2IMG(f.getAbsolutePath(),outPNGFile);
            }
            
        }catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
    public void doConvertWMF2IMG(String wmfFileStr, String imgName)
    {
        try
        {
            System.out.println("MF2IMG doConvertWMF2IMG called");
            String svgStr=doConvertWMF2SVG(wmfFileStr);
            Writer out = new OutputStreamWriter(new FileOutputStream(wmfFileStr+".svg"), "UTF-8");
            out.write(svgStr);
            out.close(); 

            SVG2IMG svg2img= new SVG2IMG();
            svg2img.doSVG2PNGConvert(wmfFileStr+".svg",imgName);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
    }


    public String doConvertWMF2SVG(String wmfFileStr)
    {
        try
        {
            if(wmfFileStr != null)
            {

                FileInputStream in = new FileInputStream(wmfFileStr);
                FileResourceWriter rw = new FileResourceWriter(new File("."));

                GDISVGSurface svg = new GDISVGSurface(rw);
                WMFParser r = new WMFParser(in, svg);
                //EMFParser r = new EMFParser(fin, svg);

                while (r.readNext()) {
                }

                return svg.getSVG();

            }
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
        return null;
    }

    public void doConvertEMF2IMG(String emfFileStr, String imgName)
    {
        try
        {
            System.out.println("MF2IMG doConvertEMF2IMG called");
            String svgStr=doConvertEMF2SVG(emfFileStr);
            Writer out = new OutputStreamWriter(new FileOutputStream(emfFileStr+".svg"), "UTF-8");
            out.write(svgStr);
            out.close(); 

            SVG2IMG svg2img= new SVG2IMG();
            svg2img.doSVG2PNGConvert(emfFileStr+".svg",imgName);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
    }


    public String doConvertEMF2SVG(String wmfFileStr)
    {
        try
        {
            if(wmfFileStr != null)
            {

                FileInputStream in = new FileInputStream(wmfFileStr);
                FileResourceWriter rw = new FileResourceWriter(new File("."));

                GDISVGSurface svg = new GDISVGSurface(rw);
                //WMFParser r = new WMFParser(in, svg);
                EMFParser r = new EMFParser(in, svg);

                while (r.readNext()) {
                }

                return svg.getSVG();

            }
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
        return null;
    }

}// end of class


